## urweb 20150214+dfsg

=== debian/changelog ===
urweb (20150214+dfsg-1) unstable; urgency=medium

  * Initial release.

 -- Benjamin Barenblat <bbaren@mit.edu>  Sun, 05 Apr 2015 15:36:51 -0400

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Build for multiarch.
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Avoid overlinking and reduce library dependencies.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Harden SML executables.
export MLTONARGS := \
	-cc-opt "$(shell dpkg-buildflags --get CPPFLAGS) \
		$(shell dpkg-buildflags --get CFLAGS)" \
	-link-opt "$(shell dpkg-buildflags --get LDFLAGS)"

%:
	dh $@ --parallel --with autoreconf

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	SRCLIB=/usr/share/urweb dh_auto_configure --

.PHONY: override_dh_auto_build
override_dh_auto_build:
	make
	cd doc && make manual.pdf

.PHONY: override_dh_builddeb
override_dh_builddeb:
	dh_builddeb -- -Zxz -z9

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg-\d+$// \
  http://impredicative.com/ur/urweb-(.+).tgz

## urweb 20160213%2Bdfsg

=== doc/Makefile ===
PAPERS=manual

FIGURES=

all: $(PAPERS:%=%.dvi) $(PAPERS:%=%.ps) $(PAPERS:%=%.pdf) 

%.dvi: %.tex $(FIGURES:%=%.eps)
	latex $<
	latex $<

%.ps: %.dvi
	dvips $< -o $@

%.pdf: %.dvi $(FIGURES:%=%.pdf)
	pdflatex $(<:%.dvi=%)

%.pdf: %.eps
	epstopdf $<

clean:
	rm -f *.aux *.bbl *.blg *.dvi *.log *.pdf *.ps

.PHONY: all clean

## urweb 20150520+dfsg

=== debian/changelog ===
urweb (20150520+dfsg-1) sid; urgency=medium

  * New upstream release.
  * Build documentation within an architecture-independent target. (Closes:
    #790512)
  * Make static linking work on multiarch systems. (Closes: #791551)
  * Correct manual page with respect to the behaviour of the -static flag.

 -- Benjamin Barenblat <bbaren@mit.edu>  Sun, 26 Jul 2015 19:10:00 -0400

urweb (20150412+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Fix debian/watch file.

 -- Benjamin Barenblat <bbaren@mit.edu>  Tue, 14 Apr 2015 16:24:31 -0400

=== debian/control ===
Source: urweb
Section: devel
Priority: extra
Maintainer: Benjamin Barenblat <bbaren@mit.edu>
Build-Depends:
 debhelper (>= 9),
 dh-autoreconf,
 dh-exec,
 libmysqlclient-dev,
 libpq-dev,
 libsqlite3-dev,
 libssl-dev,
 mlton
Build-Depends-Indep:
 emacs24 | emacsen,
 texlive-fonts-recommended,
 texlive-latex-extra
Standards-Version: 3.9.6
Homepage: http://impredicative.com/ur/

Package: urweb
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends:
 libmysqlclient-dev,
 libpq-dev,
 libsqlite3-dev,
 libssl-dev,
 liburweb0,
 liburweb-cgi0,
 liburweb-fastcgi0,
 liburweb-http0,
 liburweb-static0,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 urweb-doc,
 urweb-mode
Description: purely functional language for web programming
 Ur is a pure, functional, statically typed, strict programming language in the
 tradition of ML and Haskell; however, it features a significantly richer type
 system.  Ur/Web is Ur plus a special standard library and associated rules for
 parsing and optimization.  Ur/Web supports constructing dynamic web
 applications backed by SQL databases.
 .
 This package provides the urweb compiler and development libraries; you do not
 need to install it to run applications written in Ur/Web.

Package: liburweb0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests:
 liburweb-cgi0,
 liburweb-fastcgi0,
 liburweb-http0,
 liburweb-static0
Description: urweb runtime system
 Ur is a pure, functional, statically typed, strict programming language in the
 tradition of ML and Haskell; however, it features a significantly richer type
 system.  Ur/Web is Ur plus a special standard library and associated rules for
 parsing and optimization.  Ur/Web supports constructing dynamic web
 applications backed by SQL databases.
 .
 This package provides the runtime library for executables compiled with urweb.
 Packages should not depend on this package; instead, they should depend on one
 of the urweb backend packages, each of which depends on this one.

Package: liburweb-cgi0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: urweb CGI backend
 Ur is a pure, functional, statically typed, strict programming language in the
 tradition of ML and Haskell; however, it features a significantly richer type
 system.  Ur/Web is Ur plus a special standard library and associated rules for
 parsing and optimization.  Ur/Web supports constructing dynamic web
 applications backed by SQL databases.
 .
 This package provides the CGI backend for executables compiled with urweb.

Package: liburweb-fastcgi0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: urweb FastCGI backend
 Ur is a pure, functional, statically typed, strict programming language in the
 tradition of ML and Haskell; however, it features a significantly richer type
 system.  Ur/Web is Ur plus a special standard library and associated rules for
 parsing and optimization.  Ur/Web supports constructing dynamic web
 applications backed by SQL databases.
 .
 This package provides the FastCGI backend for executables compiled with urweb.

Package: liburweb-http0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: urweb standalone backend
 Ur is a pure, functional, statically typed, strict programming language in the
 tradition of ML and Haskell; however, it features a significantly richer type
 system.  Ur/Web is Ur plus a special standard library and associated rules for
 parsing and optimization.  Ur/Web supports constructing dynamic web
 applications backed by SQL databases.
 .
 This package provides the standalone backend for web servers generated with
 urweb.

Package: liburweb-static0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: urweb static backend
 Ur is a pure, functional, statically typed, strict programming language in the
 tradition of ML and Haskell; however, it features a significantly richer type
 system.  Ur/Web is Ur plus a special standard library and associated rules for
 parsing and optimization.  Ur/Web supports constructing dynamic web
 applications backed by SQL databases.
 .
 This package provides the static-file backend for executables compiled with
 urweb.

Package: urweb-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: xpdf | pdf-viewer
Description: Ur/Web reference manual
 Ur is a pure, functional, statically typed, strict programming language in the
 tradition of ML and Haskell; however, it features a significantly richer type
 system.  Ur/Web is Ur plus a special standard library and associated rules for
 parsing and optimization.  Ur/Web supports constructing dynamic web
 applications backed by SQL databases.
 .
 This package provides the Ur/Web reference manual in PDF format.

Package: urweb-mode
Section: editors
Architecture: all
Multi-Arch: foreign
Depends:
 emacsen-common (>= 2.0.8),
 ${misc:Depends}
Description: Emacs mode for editing Ur/Web programs
 Ur is a pure, functional, statically typed, strict programming language in the
 tradition of ML and Haskell; however, it features a significantly richer type
 system.  Ur/Web is Ur plus a special standard library and associated rules for
 parsing and optimization.  Ur/Web supports constructing dynamic web
 applications backed by SQL databases.
 .
 This package provides an Emacs mode for editing Ur/Web source files.

=== debian/rules ===
--- 
+++ 
@@ -18,13 +18,9 @@
 
 .PHONY: override_dh_auto_configure
 override_dh_auto_configure:
-	SRCLIB=/usr/share/urweb dh_auto_configure --
+	LIB=/usr/lib/$(DEB_HOST_MULTIARCH) \
+		SRCLIB=/usr/share/urweb dh_auto_configure --
 
-.PHONY: override_dh_auto_build
-override_dh_auto_build:
-	make
+.PHONY: override_dh_auto_build-indep
+override_dh_auto_build-indep:
 	cd doc && make manual.pdf
-
-.PHONY: override_dh_builddeb
-override_dh_builddeb:
-	dh_builddeb -- -Zxz -z9

## urweb 20151018+dfsg

=== debian/changelog ===
urweb (20151018+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Benjamin Barenblat <bbaren@mit.edu>  Sat, 24 Oct 2015 12:30:31 -0400

urweb (20150819+dfsg-1) experimental; urgency=medium

  * New upstream release.

 -- Benjamin Barenblat <bbaren@mit.edu>  Wed, 19 Aug 2015 11:40:08 -0400

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: extra
 Maintainer: Benjamin Barenblat <bbaren@mit.edu>
 Build-Depends:
+ curl,
  debhelper (>= 9),
  dh-autoreconf,
  dh-exec,
@@ -10,7 +11,8 @@
  libpq-dev,
  libsqlite3-dev,
  libssl-dev,
- mlton
+ mlton,
+ sqlite3
 Build-Depends-Indep:
  emacs24 | emacsen,
  texlive-fonts-recommended,

## urweb 20151122+dfsg

=== debian/changelog ===
urweb (20151122+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Benjamin Barenblat <bbaren@mit.edu>  Sun, 22 Nov 2015 11:11:20 -0500

## urweb 20151220+dfsg

=== debian/changelog ===
urweb (20151220+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Build architecture-independent targets correctly when built with
    dpkg-buildpackage -A. (Closes: #806662)

 -- Benjamin Barenblat <bbaren@mit.edu>  Wed, 23 Dec 2015 18:36:16 -0500

=== debian/control ===
--- 
+++ 
@@ -6,19 +6,21 @@
  curl,
  debhelper (>= 9),
  dh-autoreconf,
- dh-exec,
  libmysqlclient-dev,
  libpq-dev,
  libsqlite3-dev,
  libssl-dev,
  mlton,
- sqlite3
+ sqlite3,
+ uthash-dev
 Build-Depends-Indep:
  emacs24 | emacsen,
  texlive-fonts-recommended,
  texlive-latex-extra
 Standards-Version: 3.9.6
 Homepage: http://impredicative.com/ur/
+Vcs-Browser: https://github.com/urweb/debian-urweb
+Vcs-Git: git://github.com/urweb/debian-urweb.git
 
 Package: urweb
 Architecture: any
@@ -34,6 +36,7 @@
  liburweb-fastcgi0,
  liburweb-http0,
  liburweb-static0,
+ uthash-dev,
  ${shlibs:Depends},
  ${misc:Depends}
 Recommends:

## urweb 20160213%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
 Standards-Version: 3.9.6
 Homepage: http://impredicative.com/ur/
 Vcs-Browser: https://github.com/urweb/debian-urweb
-Vcs-Git: git://github.com/urweb/debian-urweb.git
+Vcs-Git: https://github.com/urweb/debian-urweb.git
 
 Package: urweb
 Architecture: any

## urweb 20160213+dfsg

=== tests/Makefile ===
all: test.o

test.o: test.c
	gcc -c test.c -o test.o

=== src/coq/Makefile ===
MODULES := Axioms Name Syntax Semantics
VS      := $(MODULES:%=%.v)

.PHONY: coq clean

coq: Makefile.coq
	make -f Makefile.coq

Makefile.coq: Makefile $(VS)
	coq_makefile -impredicative-set $(VS) -o Makefile.coq

clean:: Makefile.coq
	make -f Makefile.coq clean
	rm -f Makefile.coq

=== debian/changelog ===
urweb (20160213+dfsg-1build1) xenial; urgency=medium

  * Rebuild against libmysqlclient20.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 05 Apr 2016 13:03:59 +0000

urweb (20160213+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Benjamin Barenblat <bbaren@mit.edu>  Sat, 13 Feb 2016 11:17:06 -0500

=== debian/rules ===
--- 
+++ 
@@ -24,3 +24,13 @@
 .PHONY: override_dh_auto_build-indep
 override_dh_auto_build-indep:
 	cd doc && make manual.pdf
+
+# Tests require a working urweb binary, so don't run them on
+# architecture-independent builds.
+.PHONY: override_dh_auto_test-indep
+override_dh_auto_test-indep:
+	:
+
+.PHONY: override_dh_auto_install-indep
+override_dh_auto_install-indep:
+	DESTDIR=${CURDIR}/debian/tmp make install-exec-emacs

## urweb 20160515+dfsg

=== debian/changelog ===
urweb (20160515+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Benjamin Barenblat <bbaren@mit.edu>  Mon, 30 May 2016 17:37:29 -0400

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
  emacs24 | emacsen,
  texlive-fonts-recommended,
  texlive-latex-extra
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://impredicative.com/ur/
 Vcs-Browser: https://github.com/urweb/debian-urweb
 Vcs-Git: https://github.com/urweb/debian-urweb.git

## urweb 20160805+dfsg

=== debian/changelog ===
urweb (20160805+dfsg-1) unstable; urgency=medium

  * New upstream release. (Closes: #828587, #831088)

 -- Benjamin Barenblat <bbaren@mit.edu>  Fri, 05 Aug 2016 21:48:47 -0400

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,10 @@
 # Avoid overlinking and reduce library dependencies.
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
-# Harden SML executables.
+# Harden SML executables.  Do not build position-independent executables,
+# though; urweb depends on the MLton runtime, which is not built position-
+# independent in Debian.
+export DEB_BUILD_MAINT_OPTIONS := hardening=+all,-pie
 export MLTONARGS := \
 	-cc-opt "$(shell dpkg-buildflags --get CPPFLAGS) \
 		$(shell dpkg-buildflags --get CFLAGS)" \

## urweb 20161022+dfsg

=== debian/changelog ===
urweb (20161022+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Switch to MariaDB for MySQL support.

 -- Benjamin Barenblat <bbaren@mit.edu>  Sun, 23 Oct 2016 14:39:06 -0400

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Build-Depends:
  curl,
  debhelper (>= 9),
+ default-libmysqlclient-dev,
  dh-autoreconf,
- libmysqlclient-dev,
  libpq-dev,
  libsqlite3-dev,
  libssl-dev,
@@ -27,7 +27,7 @@
 Multi-Arch: foreign
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
- libmysqlclient-dev,
+ default-libmysqlclient-dev,
  libpq-dev,
  libsqlite3-dev,
  libssl-dev,

=== debian/rules ===
--- 
+++ 
@@ -9,12 +9,14 @@
 
 # Harden SML executables.  Do not build position-independent executables,
 # though; urweb depends on the MLton runtime, which is not built position-
-# independent in Debian.
+# independent in Debian (#837567).
 export DEB_BUILD_MAINT_OPTIONS := hardening=+all,-pie
 export MLTONARGS := \
 	-cc-opt "$(shell dpkg-buildflags --get CPPFLAGS) \
-		$(shell dpkg-buildflags --get CFLAGS)" \
-	-link-opt "$(shell dpkg-buildflags --get LDFLAGS)"
+		$(shell dpkg-buildflags --get CFLAGS) \
+		-no-pie" \
+	-link-opt "$(shell dpkg-buildflags --get LDFLAGS) \
+		-no-pie"
 
 %:
 	dh $@ --parallel --with autoreconf

## urweb 20170105+dfsg

=== debian/changelog ===
urweb (20170105+dfsg-2) unstable; urgency=medium

  * Introduce runtime dependency on GCC. (Closes: #860426)

 -- Benjamin Barenblat <bbaren@mit.edu>  Wed, 19 Apr 2017 21:48:49 -0400

urweb (20170105+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Benjamin Barenblat <bbaren@mit.edu>  Sat, 07 Jan 2017 08:48:42 -0500

urweb (20161022+dfsg-2) unstable; urgency=medium

  * Build position-independent. (Closes: #844891)

 -- Benjamin Barenblat <bbaren@mit.edu>  Sat, 31 Dec 2016 17:35:18 -0600

=== debian/control ===
--- 
+++ 
@@ -28,6 +28,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
  default-libmysqlclient-dev,
+ gcc | c-compiler,
  libpq-dev,
  libsqlite3-dev,
  libssl-dev,
@@ -40,6 +41,7 @@
  ${shlibs:Depends},
  ${misc:Depends}
 Recommends:
+ gcc,
  urweb-doc,
  urweb-mode
 Description: purely functional language for web programming

=== debian/rules ===
--- 
+++ 
@@ -7,16 +7,12 @@
 # Avoid overlinking and reduce library dependencies.
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
-# Harden SML executables.  Do not build position-independent executables,
-# though; urweb depends on the MLton runtime, which is not built position-
-# independent in Debian (#837567).
-export DEB_BUILD_MAINT_OPTIONS := hardening=+all,-pie
+# Harden SML executables.
+export DEB_BUILD_MAINT_OPTIONS := hardening=+all
 export MLTONARGS := \
 	-cc-opt "$(shell dpkg-buildflags --get CPPFLAGS) \
-		$(shell dpkg-buildflags --get CFLAGS) \
-		-no-pie" \
-	-link-opt "$(shell dpkg-buildflags --get LDFLAGS) \
-		-no-pie"
+		$(shell dpkg-buildflags --get CFLAGS)" \
+	-link-opt "$(shell dpkg-buildflags --get LDFLAGS)"
 
 %:
 	dh $@ --parallel --with autoreconf

## urweb 20170720+dfsg

=== debian/changelog ===
urweb (20170720+dfsg-2build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 23:29:27 +0000

urweb (20170720+dfsg-2) unstable; urgency=medium

  * Disable code hoisting when using MLton’s C codegen. (Closes: #871572)

 -- Benjamin Barenblat <bbaren@mit.edu>  Sun, 17 Sep 2017 17:25:24 -0400

urweb (20170720+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Bump build-dep emacs24 -> emacs25 (Closes: #870671).

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 03 Aug 2017 18:54:05 -0400

urweb (20170720+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Benjamin Barenblat <bbaren@mit.edu>  Sun, 23 Jul 2017 09:50:04 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: urweb
 Section: devel
 Priority: extra
-Maintainer: Benjamin Barenblat <bbaren@mit.edu>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Benjamin Barenblat <bbaren@mit.edu>
 Build-Depends:
  curl,
  debhelper (>= 9),
@@ -14,10 +15,10 @@
  sqlite3,
  uthash-dev
 Build-Depends-Indep:
- emacs24 | emacsen,
+ emacs25 | emacsen,
  texlive-fonts-recommended,
  texlive-latex-extra
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://impredicative.com/ur/
 Vcs-Browser: https://github.com/urweb/debian-urweb
 Vcs-Git: https://github.com/urweb/debian-urweb.git

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,10 @@
 
 # Avoid overlinking and reduce library dependencies.
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+
+# Disable GCC code hoisting to work around either a GCC bug or a MLton bug on
+# arm64 and mips64el. See https://bugs.debian.org/871572 for details.
+export DEB_CFLAGS_MAINT_APPEND := -fno-code-hoisting
 
 # Harden SML executables.
 export DEB_BUILD_MAINT_OPTIONS := hardening=+all

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg-\d+$// \
  http://impredicative.com/ur/main.html urweb-(.+).tgz
